var redrawperiod=1000; // jak casto bude dotaz na server o novych pozicich v ms

var deltatime=0;
var speedshow=1;
var urldatesat;
var urldatesatlast="";
var urldatesatlastshare="";
var datetimepauseD=null;

var map;
var geocoder;
var markeraddress;
var pointURL = "track.phtml";
var trackdrawURL = "trackdraw.phtml";
var markers = new Array();
var markersDistance = new Array();
var markersDistanceMiddle = new Array();
var markersDurationMiddle = new Array();
var markersInfowindow = new Array();
var markersCircle = new Array();
var markersDatesatD = new Array();
var polyDraw = 1;
var poly = new Array();
var rainoverlayshow = 0;
var rainoverlay = null;
var rainoverlaysrc="";
var objsDestroy = new Array();

var pointReq = new XMLHttpRequest();
var trackdrawReq = new XMLHttpRequest();

// detekce mobilniho zarizeni - vychazim z toho, ze mobilni zarizeni maji pomalejsi datove pripojeni a proto u nich snizuji obnovovaci frekvenci polohy
var isMobileDevice = false;
var uagent = navigator.userAgent.toLowerCase();
if(uagent.search("android") > -1 || uagent.search("iphone") > -1 || uagent.search("ipod") > -1) {
   isMobileDevice = true;
}

// funkce, rozsirujici schopnosti LatLng bodu o vypocet vzdalenosti mezi dvema body
google.maps.LatLng.prototype.distanceFrom = function(newLatLng) {
    var R = 6378100; // polomer zeme v metrech
    var lat1 = this.lat();
    var lon1 = this.lng();
    var lat2 = newLatLng.lat();
    var lon2 = newLatLng.lng();
    var dLat = (lat2-lat1) * Math.PI / 180;
    var dLon = (lon2-lon1) * Math.PI / 180;
    var a =
         Math.sin(dLat/2) * Math.sin(dLat/2) +
         Math.cos(lat1 * Math.PI / 180 ) * Math.cos(lat2 * Math.PI / 180 ) *
         Math.sin(dLon/2) * Math.sin(dLon/2)
    ;
    var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
    var d = R * c;
    return d;
}

function load() {
   // "skryti" adress baru u androida
   if(navigator.userAgent.match(/Android/i)) {
      // testovano zatim na SGS pri prohlizeni na sirku - viz take meta znacky v myvector.phtml
      // vice info zde: http://stackoverflow.com/questions/4068559/removing-address-bar-from-browser-to-view-on-android
      //var bodyheight=Math.round(window.outerHeight/window.devicePixelRatio);
      //if(bodyheight<=300) {
      if(window.outerHeight==442) {
         //window.scrollTo(0,0);
         //document.body.style.height=bodyheight + 'px';
         document.body.style.height='442px';
         window.scrollTo(0,1);
      }
   }
   // definice mapy
   var tdoptcenter = 1;
   var centerpoint = new google.maps.LatLng(49.584785,17.249348);
   var llstartT=document.forms['historyform']['llstart'];
   if(llstartT.value.length) {
      var llstart=llstartT.value.split(",");
      if(llstart.length>=2) {
         centerpoint = new google.maps.LatLng(llstart[0],llstart[1]);
         tdoptcenter = 0;
      }
   }
   var zoomstart=13;
   var zoomstartT=document.forms['historyform']['zoomstart'];
   if(zoomstartT.value.length) {
      zoomstart=1*zoomstartT.value;
   }
   var maptypestart=google.maps.MapTypeId.ROADMAP;
   var maptypestartT=document.forms['historyform']['maptypestart'];
   if(maptypestartT.value.length) {
      if(maptypestartT.value=='SATELLITE') {
          maptypestart=google.maps.MapTypeId.SATELLITE;
      }
      else if(maptypestartT.value=='HYBRID') {
          maptypestart=google.maps.MapTypeId.HYBRID;
      }
      else if(maptypestartT.value=='TERRAIN') {
          maptypestart=google.maps.MapTypeId.TERRAIN;
      }
   }
   var mapOptions = {
      zoom: zoomstart,
      center: centerpoint,
      scaleControl: true,
      mapTypeId: maptypestart
   }
   map = new google.maps.Map(document.getElementById("map_canvas"), mapOptions);
   // inicializace geocoder pro hledani adres
   geocoder = new google.maps.Geocoder();
   // nastaveni datetimestart pokud je zadan lik v UTC case
   if(document.forms['historyform']['datetimestartUTC'].value.length) {
      document.forms['historyform']['datetimestart'].value=formatdate(parsedateUTC(document.forms['historyform']['datetimestartUTC'].value));
   }
   // nastaveni tdstart a tdend pokud je zadan lik v UTC case
   if(document.forms['trackdrawform']['tdstartUTC'].value.length) {
      document.forms['trackdrawform']['tdstart'].value=formatdate(parsedateUTC(document.forms['trackdrawform']['tdstartUTC'].value));
   }
   if(document.forms['trackdrawform']['tdendUTC'].value.length) {
      document.forms['trackdrawform']['tdend'].value=formatdate(parsedateUTC(document.forms['trackdrawform']['tdendUTC'].value));
   }
   // vypocet vychoziho deltatime, dle nastavene hodnoty v "Startovni cas"
   calcdeltatime();
   //
   startDraw();
   //
   var tduser=document.forms['trackdrawform']['tduser'].value;
   if(tduser.length) {
      trackdraw({center: tdoptcenter});
   }
}

function pauseonoff() {
   var pbT=document.getElementById('map_pause');
   if(pbT.value=='Pauza') {
      pbT.value='Zapni';
      if (pointReq) {
         pointReq.abort();
         var btT=document.getElementById('map_boxtime');
         btT.style.backgroundColor="";
      }
      if(deltatime>0) {
         datetimepauseD=new Date;
      }
   }
   else {
      pbT.value='Pauza';
      if(datetimepauseD!=null && deltatime>0) {
         var datetimenowD=new Date;
         // tahle korekce deltatime je tu proto, aby pri koukani v minulosti,
         // kdyz dojde k Pauze a pozdeji k Zapni, aby cas pokracoval dal, kde
         // pri Pauze skoncil
         deltatime+=datetimenowD.getTime()-datetimepauseD.getTime();
      }
      startDraw();
   }
}

function startDraw() {
   window.setTimeout("drawPoints()",0); // setTimeout asi zajisti, ze to vlastne pobezi jak dalsi vlakno
   window.setTimeout("checkNetwork()",10000); // funkce, ktera pripadne obnovi vykreslovani - pokud spadlo napriklad prerusenim spojeni
}

function checkNetwork() {
   if(document.getElementById('map_pause').value=='Zapni') { return; };
   if (pointReq && pointReq.readyState == 4 && pointReq.status != 200) {
      pointReq.abort();
      var btT=document.getElementById('map_boxtime');
      btT.style.backgroundColor="#ff8585";
      // obnova vykreslovaci "smycky"
      window.setTimeout("drawPoints()",redrawperiod);
   }
   // "smycka" - kontrola cprobiha co 10s
   window.setTimeout("checkNetwork()",10000);
}

function drawPoints() {
   if(document.getElementById('map_pause').value=='Zapni') { return; };
   if (pointReq && pointReq.readyState < 4) {
      pointReq.abort();
      var btT=document.getElementById('map_boxtime');
      btT.style.backgroundColor="#ff8585";
   }
   urldatesat=calctrackdate();
   deltatime-=1000*(speedshow-1); // posun deltatime pri nastavenem zrychleni
   var urlreq = pointURL + '?datesat=' + encodeURIComponent(urldatesat) + '&datesatlast=' + encodeURIComponent(urldatesatlast) + '&datesatlastshare=' + encodeURIComponent(urldatesatlastshare);
   if(rainoverlayshow) {
      urlreq += '&rainoverlay=' + encodeURIComponent('1');
   }
   pointReq.open("GET", urlreq);
   pointReq.onreadystatechange = function() { redrawPoints(); };
   pointReq.send(null);
}

function redrawPoints() {
   if (pointReq && pointReq.readyState == 4 && pointReq.status == 200) {
      var btT=document.getElementById('map_boxtime');
      btT.style.backgroundColor="#84ff70";
      var xmlDoc = pointReq.responseXML;
      var urldatesatlastT=xmlDoc.documentElement.getElementsByTagName("DlP")[0];
      if(urldatesatlastT.firstChild) {
         urldatesatlast=urldatesatlastT.firstChild.nodeValue;
      }
      var urldatesatlastshareT=xmlDoc.documentElement.getElementsByTagName("DlS")[0];
      if(urldatesatlastshareT.firstChild) {
         urldatesatlastshare=urldatesatlastshareT.firstChild.nodeValue;
      }
      var placemarks = xmlDoc.documentElement.getElementsByTagName("Pm");
      for (var i = 0; i < placemarks.length; i++) {
         redrawPoint(placemarks[i],false);
      }
      // pripadne autovycentrovani
      var autocenterT=document.getElementById('autocenter');
      if(autocenterT.checked && autocenterT.value.length) {
         centerMap(autocenterT.value);
      }
      // vykresleni sdilenych medialnich dat (fotografii)
      var sharemarks = xmlDoc.documentElement.getElementsByTagName("Sm");
      for (var i = 0; i < sharemarks.length; i++) {
         drawSharepoint(sharemarks[i],false);
      }
      // pripadna zmena rainoverlay
      if(xmlDoc.documentElement.getElementsByTagName("Rainoverlay").length) {
         rainoverlaysrc=xmlDoc.documentElement.getElementsByTagName("Rainoverlay")[0].getAttribute("src");
         if(rainoverlayshow) {
            if(rainoverlay != null) {
               if(rainoverlay.getImgsrc()!=rainoverlaysrc) {
                  rainoverlay.setImgsrc(rainoverlaysrc);
                  var rainoverlaybutton = document.getElementById("rainoverlaybutton");
                  rainoverlaybutton.value="Skrýt srážky z "+rainoverlaytime();
               }
            }
            else {
               rainoverlayshownew();
            }
         }
      }
      // "smycka"
      window.setTimeout("drawPoints()",redrawperiod);
   }
}

function basePoint (placemark,isTrackDraw) {
   var name, namePrint;
   if(isTrackDraw) {
      name = '@TrackDraw';
      namePrint = placemark.getElementsByTagName("n")[0].firstChild.nodeValue;
   }
   else {
      name = placemark.getElementsByTagName("n")[0].firstChild.nodeValue;
      namePrint = name;
   }
   var foto_src, foto_href, foto_style;
   if(placemark.getElementsByTagName("f").length) {
      foto_src=placemark.getElementsByTagName("f")[0].getAttribute("src");
      foto_href=placemark.getElementsByTagName("f")[0].getAttribute("href");
      foto_style=placemark.getElementsByTagName("f")[0].getAttribute("style");
   }
   var description = placemark.getElementsByTagName("r")[0].firstChild.nodeValue; // zatim nezobrazuji
   var pointT = placemark.getElementsByTagName("Pt")[0];
   var coord = pointT.getElementsByTagName("c")[0];
   var coordval = coord.firstChild.nodeValue;
   var c1 = coordval.indexOf(",");
   var c2 = coordval.indexOf(",",c1+1);
   if(c2 < c1) {
      c2 = coordval.length;
   }
   var Plo = parseFloat(coordval.substring(0,c1));
   var Pla = parseFloat(coordval.substring(c1+1,c2));
   var PA = parseFloat(coordval.substring(c2+1));
   var accuracy = parseFloat(pointT.getElementsByTagName("a")[0].firstChild.nodeValue);
   var datesat = pointT.getElementsByTagName("d")[0].firstChild.nodeValue;
   var point = new google.maps.LatLng(Pla,Plo);
   var infotext = '';
   infotext += 
      '<div><b>' + namePrint + '</b></div>'
   ;
   if(foto_src!=undefined) {
      infotext += 
         '<div style="float: left; margin-right: 6px; margin-bottom: 6px;"><a href="' + foto_href + '" target="_blank"><img style="' + foto_style + '" src="' + foto_src + '" /></a></div>'
      ;
   }
   infotext += 
      '<div style="float: left; font-size: 80%;">' +
         '<div><i>Datum:</i> ' + formatdate(parsedateUTC(datesat)) + '</div>' +
         '<div>' +
            '<i>Loc:</i> ' + Pla + ' ' + Plo
   ;
   if(pointT.getElementsByTagName("p").length) {
      var provider = pointT.getElementsByTagName("p")[0].firstChild.nodeValue;
      infotext += ' (' + provider + ')';
   }
   infotext += 
            ' ' +
            '<sup><a href="http://www.google.com/maps?z=12&q=loc%3A' + Pla + '%20' + Plo + '" target="_blank" title="skoč na Google mapy">' + 'g' + '</a></sup>' +
            ' ' +
            '<sup><a href="http://www.mapy.cz/?z=10&q=loc%3A' + Pla + '%20' + Plo + '" target="_blank" title="skoč na Seznam mapy">' + 's' + '</a></sup>' +
         '</div>' +
         '<div><i>Nadmořská výška</i>: ' + PA + ' m</div>'
   ;
   if(pointT.getElementsByTagName("s").length) {
      var speed = parseFloat(pointT.getElementsByTagName("s")[0].firstChild.nodeValue);
      infotext += 
            '<div><i>Rychlost</i>: ' + speed + ' km/h</div>'
      ;
   }
   if(pointT.getElementsByTagName("b").length) {
      var battlevel = parseFloat(pointT.getElementsByTagName("b")[0].firstChild.nodeValue);
      var charging = parseInt(pointT.getElementsByTagName("e")[0].firstChild.nodeValue);
      var chargingtext;
      if(charging) {
         chargingtext='nabíjí se';
      }
      else {
         chargingtext='vybíjí se';
      }
      infotext += 
         '<div><i>Baterie:</i> ' + battlevel + ' % (' + chargingtext + ')</div>'
      ;
   }
   if(pointT.getElementsByTagName("no").length) {
      var networkoperatorname = pointT.getElementsByTagName("no")[0].firstChild.nodeValue;
      var networktype = parseInt(pointT.getElementsByTagName("nt")[0].firstChild.nodeValue);
      var networktypetext;
      if(networktype==0) {
         networktypetext='?';
      }
      else if(networktype==1) {
         networktypetext='gprs';
      }
      else if(networktype==2) {
         networktypetext='edge';
      }
      else if(networktype==3) {
         networktypetext='umts';
      }
      else if(networktype==8) {
         networktypetext='hspda';
      }
      else if(networktype==9) {
         networktypetext='hsupa';
      }
      else if(networktype==10) {
         networktypetext='hspa';
      }
      else {
         networktypetext=''+networktype;
      }
      infotext += 
         '<div><i>GSM:</i> ' + networkoperatorname + ' (' + networktypetext + ')</div>'
      ;
   }
   infotext += 
      '</div>'
   ;
   return {
      name: name,
      namePrint: namePrint,
      datesat: datesat,
      Pla: Pla,
      Plo: Plo,
      accuracy: accuracy,
      infotext: infotext
   };
}

function drawSharepoint(placemark,isTrackDraw) {
   var bP=basePoint(placemark,isTrackDraw);
   var name=bP.name;
   var namePrint=bP.namePrint;
   var accuracy=bP.accuracy;
   var datesat=bP.datesat;
   var infotext=bP.infotext;
   var point = new google.maps.LatLng(bP.Pla,bP.Plo);
   var markerShare = new google.maps.Marker({
      position: point
   });
   // tohle je zjednodusena forma predhozenim url v setIcon - muzes vsak predhodit MarkerImage, kde se da nastavit hodne parametru
   markerShare.setIcon("share/icons/yellow_Marker"+namePrint.substring(0,1).toUpperCase()+".png");
   var markerInfowindowShare = new google.maps.InfoWindow({
      content: infotext
   });
   var markerShareImageOpen = new google.maps.MarkerImage(
         "share/icons/yellow_Triangle.png",
         new google.maps.Size(12, 12),
         new google.maps.Point(0, 0),
         new google.maps.Point(6, 1)
   );
   google.maps.event.addListener(markerShare, 'click', function() {
      if(markerInfowindowShare.getMap()) {
         markerInfowindowShare.close();
         markerShare.setIcon("share/icons/yellow_Marker"+namePrint.substring(0,1).toUpperCase()+".png");
      }
      else {
         markerShare.setIcon(markerShareImageOpen);
         markerInfowindowShare.open(map,markerShare);
      }
   });
   var markerCircleShare = new google.maps.Circle({
      fillColor: '#00f',
      fillOpacity: 0.1,
      strokeColor: '#00f',
      strokeOpacity: 0.3,
      strokeWeight: 1,
      clickable: false
   });
   markerCircleShare.bindTo('center', markerShare, 'position');
   markerCircleShare.setRadius(accuracy);
   markerShare.setMap(map);
   markerCircleShare.setMap(map);
   // pamatovak znacek pro pripadne jejich vymazani po nastaveni jineho casu mapy
   if(!isTrackDraw) {
      objsDestroy.push(markerShare,markerCircleShare);
   }
   return markerShare;
}

function redrawPoint(placemark,isTrackDraw) {
   var bP=basePoint(placemark,isTrackDraw);
   var name=bP.name;
   var namePrint=bP.namePrint;
   var accuracy=bP.accuracy;
   var datesat=bP.datesat;
   var infotext=bP.infotext;
   var point = new google.maps.LatLng(bP.Pla,bP.Plo);
   if (markers[name]) {
      var drawNewPoly=0
      if(Math.abs(parsedateUTC(datesat).getTime()-markersDatesatD[name].getTime())>127000) { // pokud je prodleva oproti predchozi pozici vetsi jak 2 minuty a 7s (127000ms) zacnu malovat novou caru
         drawNewPoly=1;
      }
      if(drawNewPoly) {
         if(polyDraw) {
            endPolyline(poly[name],name,isTrackDraw);
         }
      }
      else {
         var distance = point.distanceFrom(markers[name].getPosition());
         var duration = parsedateUTC(datesat).getTime() - markersDatesatD[name].getTime();
         markersDistance[name] += distance;
         var distanceText;
         if(markersDistance[name]<1000) {
            distanceText = Math.round(markersDistance[name]) + ' m';
         }
         else {
            distanceText = Math.round(markersDistance[name]/1000*10)/10 + ' km';
         }
         infotext += 
            '<div style="font-size: 80%;">' +
            '<i>Vzdálenost:</i> ' + distanceText +
            '</div>'
         ;
         var freq;
         var speedavg;
         if(markersDurationMiddle[name] != 0) {
            speedavg = markersDistanceMiddle[name] / markersDurationMiddle[name]; // v m/ms
         }
         if(speedavg * 1000 <= 2.8) { // 2.8 m/s je asi 10km/h
             freq=100; // pri pomalem (pesim) presunu delam body po 100m
         }
         else {
             freq=1000; // pri rychlem presunu delam body po 1000m
         }
         if(markersDistanceMiddle[name]>=freq) {
            middlePolyline(poly[name],name,isTrackDraw);
            // neprovedu uplne vynulovani, jelikoz to chci mit pokud mozno po pravidelnych usecich,
            // ale body mam s ruznym opozdenim a vynulovanim by mi inkrementalne narustala nejaka
            // chubova vzdalenost a vice by se to odlisovalo od pravidelnych useku
            markersDistanceMiddle[name] -= freq;
            if(speedavg != 0) {
               markersDurationMiddle[name] = markersDistanceMiddle[name] / speedavg;
            }
            else {
               markersDurationMiddle[name] = 0;
            }
         }
         markersDistanceMiddle[name] += distance;
         markersDurationMiddle[name] += duration;
      }
      markersInfowindow[name].setContent(infotext);
      markers[name].setPosition(point);
      markersCircle[name].setRadius(accuracy);
      markersDatesatD[name]=parsedateUTC(datesat);
      if(drawNewPoly) {
         if(polyDraw) {
            poly[name]=newPolyline(name,namePrint,isTrackDraw);
         }
      }
      if(polyDraw) {
         var path = poly[name].getPath();
         path.push(point);
      }
   }
   else {
      markers[name] = new google.maps.Marker({
         position: point
      });
      var markercolor;
      if(name.substring(1,2)>'9') {
         markercolor="red";
      }
      else {
         markercolor="blue";
      }
      // tohle je zjednodusena forma predhozenim url v setIcon - muzes vsak predhodit MarkerImage, kde se da nastavit hodne parametru
      markers[name].setIcon("share/icons/"+markercolor+"_Marker"+namePrint.substring(0,1).toUpperCase()+".png");
      markersDistance[name] = 0;
      markersDistanceMiddle[name] = 0;
      markersDurationMiddle[name] = 0;
      markersInfowindow[name] = new google.maps.InfoWindow({
         content: infotext
      });
      google.maps.event.addListener(markers[name], 'click', function() {
         if(markersInfowindow[name].getMap()) {
            markersInfowindow[name].close();
         }
         else {
            markersInfowindow[name].open(map,markers[name]);
         }
      });
      markersCircle[name] = new google.maps.Circle({
         fillColor: '#00f',
         fillOpacity: 0.1,
         strokeColor: '#00f',
         strokeOpacity: 0.3,
         strokeWeight: 1,
         clickable: false
      });
      markersCircle[name].bindTo('center', markers[name], 'position');
      markersCircle[name].setRadius(accuracy);
      markersDatesatD[name]=new Date;
      markersDatesatD[name]=parsedateUTC(datesat);
      if(polyDraw) {
         poly[name]=newPolyline(name,namePrint,isTrackDraw);
         var path = poly[name].getPath();
         path.push(point);
      }
      // zobrazeni znacky na mape (u trackdraw ji vsak nezobrazuji)
      if(!isTrackDraw) {
         markers[name].setMap(map);
         markersCircle[name].setMap(map);
      }
      // zobrazeni noveho clena v pravo
      if(!isTrackDraw) {
         var mmT=document.getElementById("map_markers");
         var odmmT=document.createElement("DIV");
         var osmmT=document.createElement("SPAN");
         var nameT=document.createTextNode(name);
         osmmT.appendChild(nameT);
         osmmT.setAttribute(
            "onclick",
            "centerMap('"+name+"'); var autocenterT=document.getElementById('autocenter'); autocenterT.value='"+name+"';"
         );
         odmmT.appendChild(osmmT);
         mmT.appendChild(odmmT);
      }
   }
}

function newPolyline(name,namePrint,isTrackDraw) {
   var polynew = new google.maps.Polyline({
      strokeWeight: 3,
      strokeOpacity: 0.8
   });
   setStrkeColorByUser(polynew,namePrint);
   polynew.setMap(map);
   var markerStart = new google.maps.Marker({
         position: markers[name].getPosition()
   });
   markerStart.setIcon("share/icons/green_MarkerZ.png");
   var infoonclick=
      "document.forms['historyform']['datetimestart'].value='" + formatdate(markersDatesatD[name]) + "';" +
      "document.forms['historyform']['speedshow'].value='10';" +
      "calcdeltatime()"
   ;
   var markerInfowindowStart = new google.maps.InfoWindow({
      content: markersInfowindow[name].getContent() + '<div style="font-size: 80%; color: blue; cursor: pointer;" onclick="' + infoonclick + '">' + 'přehrej cestu</div>'
   });
   google.maps.event.addListener(markerStart, 'click', function() {
      if(markerInfowindowStart.getMap()) {
         markerInfowindowStart.close();
      }
      else {
         markerInfowindowStart.open(map,markerStart);
      }
   });
   google.maps.event.addListener(polynew, 'click', function(event) {
      if(polynew.strokeColor!='#00dd00') {
         polynew.setOptions({strokeColor: '#00dd00'});
      }
      else {
         setStrkeColorByUser(polynew,namePrint);
      }
      if(polynew.strokeColor!='#00dd00') {
         markerStart.setMap(null);
      }
      else {
         markerStart.setMap(map);
      }
   });
   // pamatovak znacek pro pripadne jejich vymazani po nastaveni jineho casu mapy
   if(!isTrackDraw) {
      objsDestroy.push(markerStart);
      if(poly[name]) {
         objsDestroy.push(poly[name]);
      }
   }
   return polynew;
}

function setStrkeColorByUser(polynew,namePrint) {
   var remoteuser=document.forms['trackdrawform']['remoteuser'].value;
   if(namePrint == remoteuser) {
      polynew.setOptions({strokeColor: '#ff0000'});
   }
   else {
      polynew.setOptions({strokeColor: '#0000ff'});
   }
}

function middlePolyline(polyold,name,isTrackDraw) {
   var markerMiddle = new google.maps.Marker({
         position: markers[name].getPosition()
   });
   var markerMiddleImage = new google.maps.MarkerImage(
         "share/icons/green_Circle.png",
         new google.maps.Size(8, 8),
         new google.maps.Point(0, 0),
         new google.maps.Point(4, 4)
   );
   markerMiddle.setIcon(markerMiddleImage);
   var infoonclick=
      "document.forms['historyform']['datetimestart'].value='" + formatdate(markersDatesatD[name]) + "';" +
      "document.forms['historyform']['speedshow'].value='10';" +
      "calcdeltatime()"
   ;
   var markerInfowindowMiddle = new google.maps.InfoWindow({
      content: markersInfowindow[name].getContent() + '<div style="font-size: 80%; color: blue; cursor: pointer;" onclick="' + infoonclick + '">' + 'přehrej cestu</div>'
   });
   google.maps.event.addListener(markerMiddle, 'click', function() {
      if(markerInfowindowMiddle.getMap()) {
         markerInfowindowMiddle.close();
      }
      else {
         markerInfowindowMiddle.open(map,markerMiddle);
      }
   });
   google.maps.event.addListener(polyold, 'click', function(event) {
      if(polyold.strokeColor!='#00dd00') {
         markerMiddle.setMap(null);
      }
      else {
         markerMiddle.setMap(map);
      }
   });
   if(polyold.strokeColor!='#00dd00') {
      markerMiddle.setMap(null);
   }
   else {
      markerMiddle.setMap(map);
   }
   // pamatovak znacek pro pripadne jejich vymazani po nastaveni jineho casu mapy
   if(!isTrackDraw) {
      objsDestroy.push(markerMiddle);
   }
}

function endPolyline(polyold,name,isTrackDraw) {
   var markerEnd = new google.maps.Marker({
         position: markers[name].getPosition()
   });
   markerEnd.setIcon("share/icons/green_MarkerK.png");
   var markerInfowindowEnd = new google.maps.InfoWindow({
      content: markersInfowindow[name].getContent()
   });
   google.maps.event.addListener(markerEnd, 'click', function() {
      if(markerInfowindowEnd.getMap()) {
         markerInfowindowEnd.close();
      }
      else {
         markerInfowindowEnd.open(map,markerEnd);
      }
   });
   google.maps.event.addListener(polyold, 'click', function(event) {
      if(polyold.strokeColor!='#00dd00') {
         markerEnd.setMap(null);
      }
      else {
         markerEnd.setMap(map);
      }
   });
   if(polyold.strokeColor!='#00dd00') {
      markerEnd.setMap(null);
   }
   else {
      markerEnd.setMap(map);
   }
   markersDistance[name] = 0;
   markersDistanceMiddle[name] = 0;
   markersDurationMiddle[name] = 0;
   // pamatovak znacek pro pripadne jejich vymazani po nastaveni jineho casu mapy
   if(!isTrackDraw) {
      objsDestroy.push(markerEnd);
   }
}

function centerMap(centername) {
   for (var name in markers) {
      if(name == centername) {
         var centerpoint = markers[name].getPosition();
         map.setCenter(centerpoint);
         break;
      }
   }
}


//--- pomocne funkce pro prehravani minulosti a pritomnosti (zejmena) ---
function calcdeltatime() {
   var btT=document.getElementById('map_boxtime');
   btT.style.backgroundColor="";
   var abort=0;
   if (pointReq && pointReq.readyState < 4) {
      pointReq.abort();
      abort=1;
      var btT=document.getElementById('map_boxtime');
      btT.style.backgroundColor="#ff8585";
   }
   urldatesatlast="";
   urldatesatlastshare="";
   //
   var datetimestart=document.forms['historyform']['datetimestart'].value;
   if(datetimestart.length) {
      var datetimenowD=new Date;
      var datetimestartD=parsedate(datetimestart); // funkce parsedate predpoklada, ze z formulare je zadan cas v lokalnim casovem pasmu (tedy ne v GMT ci UTC)
      deltatime=datetimenowD.getTime()-datetimestartD.getTime();
      if(deltatime<=0 || isNaN(deltatime)) {
         deltatime=0;
      }
      datetimestartD.setTime(datetimenowD.getTime()-deltatime);
      document.forms['historyform']['datetimestart'].value=formatdate(datetimestartD);
   }
   else {
      deltatime=0;
   }
   calcspeedshow();
   // vymazani vsech pripadne jiz drive nakreslenych znacek - nejsem si jist zda se vse pekne opravdu vycisti i z pameti
   for (var name in markers) {
      markers[name].setMap(null);
      markers[name]=null;
      delete markers[name];
      markersInfowindow[name]=null;
      delete markersInfowindow[name];
      markersCircle[name].setMap(null);
      markersCircle[name]=null;
      delete markersCircle[name];
      poly[name].setMap(null);
      poly[name]=null;
      delete poly[name];
   }
   // vymazani vsech dalsich znacek urcenych ke zruseni (vetsinou jde veci souvisejici se znackami share (fotkami))
   var objDestroy=objsDestroy.pop();
   while(objDestroy) {
      objDestroy.setMap(null);
      objDestroy=null;
      objDestroy=objsDestroy.pop();
   }
   // vymazani aktivnich uzivatelu
   var mmT=document.getElementById("map_markers");
   while (mmT.hasChildNodes()) {
      mmT.removeChild(mmT.firstChild);
   }
   // pripadne zruseni hladiny srazek (pokud je zapnuto jeji zobrazovani, musi se znovu nacist s aktualnimi udaji)
   rainoverlaydestroy();
   rainoverlaysrc="";
   rainoverlaybuttonnewupdate();
   // pokud je pri nastav zrovna puznuto je treba vynulovat datetimepauseD
   datetimepauseD=null;
   // pokud doslo vyse k preruseni
   if(abort) {
      window.setTimeout("drawPoints()",0);
   }
}

function calcspeedshow() {
   var speedshowtmp=1*document.forms['historyform']['speedshow'].value;
   if(speedshowtmp<=0 || isNaN(speedshowtmp)) {
      speedshowtmp=1;
   }
   else if(speedshowtmp>60) {
      speedshowtmp=60;
   }
   speedshow=speedshowtmp;
   document.forms['historyform']['speedshow'].value=speedshow;
}

function calctrackdate() {
   var trackdate;
   var trackdatelocal;
   if(deltatime>0 || isMobileDevice) {
      var datetimenowD=new Date;
      var datetimetrackD=new Date;
      datetimetrackD.setTime(datetimenowD.getTime()-deltatime);
      trackdate=formatdateUTC(datetimetrackD);
      trackdatelocal=formatdate(parsedateUTC(trackdate));
      redrawperiod=3000; // minulost prekresluji po 3s
   }
   else {
      trackdate="9999-12-31 00:00:00";
      var datetimenowD=new Date;
      trackdatelocal=formatdate(datetimenowD);
      redrawperiod=1000; // pritomnost prekresluji po 1s
   }
   // tisk aktualniho casu doprava nahoru
   var mtT = document.getElementById("map_time");
   mtT.firstChild.nodeValue = trackdatelocal;
   return trackdate;
}


//--- vykreslovani trasy ---
function trackdraw(tdopt) {
   var tdstarturl;
   var tdstart=document.forms['trackdrawform']['tdstart'].value;
   var tdstartD;
   if(tdstart.length>=10) {
      tdstartD=parsedate(tdstart); // funkce parsedate predpoklada, ze z formulare je zadan cas v lokalnim casovem pasmu (tedy ne v GMT ci UTC)
   }
   if(Object.prototype.toString.call(tdstartD) != "[object Date]" || isNaN(tdstartD.getTime())) {
      tdstartD=new Date;
      tdstartD=parsedate(formatdate(tdstartD).substring(0,10));
   }
   tdstarturl=formatdateUTC(tdstartD);
   document.forms['trackdrawform']['tdstart'].value=formatdate(tdstartD);
   var tdendurl;
   var tdend=document.forms['trackdrawform']['tdend'].value;
   var tdendD;
   if(tdend.length>=10) {
       tdendD=parsedate(tdend); // funkce parsedate predpoklada, ze z formulare je zadan cas v lokalnim casovem pasmu (tedy ne v GMT ci UTC)
   }
   if(Object.prototype.toString.call(tdendD) != "[object Date]" || isNaN(tdendD.getTime())) {
      tdendD=new Date;
      tdendD=parsedate(formatdate(tdendD).substring(0,10)+" 24:00:00");
   }
   tdendurl=formatdateUTC(tdendD);
   document.forms['trackdrawform']['tdend'].value=formatdate(tdendD);
   var tduser=document.forms['trackdrawform']['tduser'].value;
   if(!tduser.length) {
      tduser=document.forms['trackdrawform']['remoteuser'].value;
      document.forms['trackdrawform']['tduser'].value=tduser;
   }
   trackdrawReq.open("GET", trackdrawURL + '?tdstart=' + encodeURIComponent(tdstarturl) + '&tdend=' + encodeURIComponent(tdendurl) + '&tduser=' + encodeURIComponent(tduser));
   trackdrawReq.onreadystatechange = function() { trackdrawPoints(tdopt); };
   trackdrawReq.send(null);
}

function trackdrawPoints(tdopt) {
   if (trackdrawReq && trackdrawReq.readyState == 4 && trackdrawReq.status == 200) {
      var xmlDoc = trackdrawReq.responseXML;
      var centerpoint;
      var placemarks = xmlDoc.documentElement.getElementsByTagName("Pm");
      if(placemarks.length) {
         var name = '@TrackDraw';
         for (var i = 0; i < placemarks.length; i++) {
            redrawPoint(placemarks[i],true);
            if(i==0) {
               centerpoint=markers[name].getPosition();
            }
         }
         endPolyline(poly[name],name);
         // zapomenuti markers - aby namalovane cary zustaly a zapomenulo se na ne ze tam jsou a nebyly take smazany pri nastaveni prehravani
         markers[name] = null;
         delete markers[name];
      }
      var sharemarks = xmlDoc.documentElement.getElementsByTagName("Sm");
      for (var i = 0; i < sharemarks.length; i++) {
         var markerShare=drawSharepoint(sharemarks[i],true);
         if(i==0 && centerpoint==undefined) {
            centerpoint=markerShare.getPosition();
         }
      }
      // vycentruj mapu na pocatecni pozici vykreslene trasy
      if(tdopt.center && centerpoint!=undefined) {
         map.setCenter(centerpoint);
      }
   }
}


//--- vyhledavani ---
function addressfind() {
   if(markeraddress) {
      markeraddress.setMap(null);
      markeraddress=null;
   }
   var address = document.getElementById("addresstext").value;
   geocoder.geocode(
      { 'address': address },
      function(results, status) {
         if (status == google.maps.GeocoderStatus.OK) {
            map.setCenter(results[0].geometry.location);
            markeraddress = new google.maps.Marker({
               map: map, 
               position: results[0].geometry.location
            });
         }
         else {
            alert("Adresa nenalezena. (" + status + ")");
         }
      }
   );
}

function addressfindBasicReverse(tT,point) {
   geocoder.geocode(
      { latLng: point },
      function(results, status) {
         if (status == google.maps.GeocoderStatus.OK) {
            var text=results[0].formatted_address;
            var textT=document.createTextNode(text);
            tT.appendChild(textT);
         }
      }
   );
}

//--- srazky ---
function rainoverlaytoggle() {
   rainoverlaydestroy();
   if(rainoverlayshow) {
      rainoverlayshow=0;
   }
   else {
      rainoverlayshow=1;
      rainoverlayshownew();
   }
   rainoverlaybuttonnewupdate();
}

function rainoverlaybuttonnewupdate() {
   var rainoverlaybutton = document.getElementById("rainoverlaybutton");
   if(rainoverlayshow) {
      rainoverlaybutton.value="Skrýt srážky";
   }
   else {
      rainoverlaybutton.value="Zobrazit srážky";
   }
}

function rainoverlaydestroy() {
   if(rainoverlay != null) {
      rainoverlay.setMap(null);
      rainoverlay = null;
   }
   var legendT = document.getElementById("rainoverlaylegend");
   if(legendT) {
      document.body.removeChild(legendT);
   }
}

function rainoverlayshownew() {
   if(rainoverlaysrc.length) {
      var bounds;
      var offs = rainoverlaysrc.length-17;
      // vlozeni mapy s transformovanou projekci na mercator
      if(rainoverlaysrc.substring(12+offs,1+12+offs)=='M') {
         --offs;
         var swPt = new google.maps.LatLng(47.1,9.898);
         var nePt = new google.maps.LatLng(52.01,20.31);
         bounds = new google.maps.LatLngBounds(swPt, nePt);
      }
      // napasovani mapy s nezmenenou projekci
      else {
         var swPt = new google.maps.LatLng(47.23,10.25);
         var nePt = new google.maps.LatLng(51.85,20.33);
         bounds = new google.maps.LatLngBounds(swPt, nePt);
      }
      rainoverlay = new USGSOverlay(bounds, rainoverlaysrc, 0.5, map);
      var legendT=document.createElement("DIV");
      legendT.setAttribute("id","rainoverlaylegend");
      legendT.setAttribute("style","position: fixed; bottom: 1em; right: 26%;");
      var legendimgT=document.createElement("IMG");
      legendimgT.setAttribute("src","overlay/rainfall/legend.png");
      legendT.appendChild(legendimgT);
      document.body.appendChild(legendT);
      var rainoverlaybutton = document.getElementById("rainoverlaybutton");
      rainoverlaybutton.value="Skrýt srážky z "+rainoverlaytime();
   }
}

function rainoverlaytime() {
   var offs = rainoverlaysrc.length-17;
   if(rainoverlaysrc.substring(12+offs,1+12+offs)=='M') {
      --offs;
   }
   var rainoverlayD=parsedateUTC(rainoverlaysrc.substring(0+offs,4+0+offs) + "-" + rainoverlaysrc.substring(4+offs,4+2+offs) + "-" + rainoverlaysrc.substring(6+offs,2+6+offs) + " " + rainoverlaysrc.substring(9+offs,2+9+offs) + ":" + rainoverlaysrc.substring(11+offs,2+11+offs) + ":00");
   return formatdate(rainoverlayD).substring(11,16);
}

//--- link na cisty myvector a na nastaveny ---
function myvectorcurbase() {
   var centerpoint = map.getCenter();
   var maptypestart='ROADMAP';
   if(map.getMapTypeId()==google.maps.MapTypeId.SATELLITE) {
      maptypestart='SATELLITE';
   }
   else if(map.getMapTypeId()==google.maps.MapTypeId.HYBRID) {
      maptypestart='HYBRID';
   }
   else if(map.getMapTypeId()==google.maps.MapTypeId.TERRAIN) {
      maptypestart='TERRAIN';
   }
   return '?llstart=' + encodeURIComponent(centerpoint.toUrlValue()) + '&zoomstart=' + encodeURIComponent(map.getZoom()) + '&maptypestart=' + encodeURIComponent(maptypestart);
}

function myvectornew(aT) {
   aT.href += myvectorcurbase();
   return true;
}

function myvectorcur(aT) {
   aT.href += myvectorcurbase();
   if(document.forms['historyform']['datetimestart'].value.length) {
      aT.href += '&datetimestartUTC=' + formatdateUTC(parsedate(document.forms['historyform']['datetimestart'].value));
   }
   if((1*document.forms['historyform']['speedshow'].value)>1) {
      aT.href += '&speedshow=' + (1*document.forms['historyform']['speedshow'].value);
   }
   var autocenterT=document.getElementById('autocenter');
   if(autocenterT.checked && autocenterT.value.length) {
      aT.href += '&autocenter=' + autocenterT.value;
   }
   if(document.forms['trackdrawform']['tduser'].value.length) {
      aT.href += '&tduser=' + document.forms['trackdrawform']['tduser'].value;
   }
   if(document.forms['trackdrawform']['tdstart'].value.length) {
      aT.href += '&tdstartUTC=' + formatdateUTC(parsedate(document.forms['trackdrawform']['tdstart'].value));
   }
   if(document.forms['trackdrawform']['tdend'].value.length) {
      aT.href += '&tdendUTC=' + formatdateUTC(parsedate(document.forms['trackdrawform']['tdend'].value));
   }
   return true;
}

