//--- pomocne funkce ---
function parsedateUTC(datestr) {
   var d = new Date();
   d.setUTCFullYear(datestr.substring(0,4), datestr.substring(5,7)-1, datestr.substring(8,10));
   d.setUTCHours(datestr.substring(11,13));
   d.setUTCMinutes(datestr.substring(14,16));
   d.setUTCSeconds(datestr.substring(17,19));
   return d;
}
function parsedate(datestr) {
   var d = new Date();
   d.setFullYear(datestr.substring(0,4), datestr.substring(5,7)-1, datestr.substring(8,10));
   d.setHours(datestr.substring(11,13));
   d.setMinutes(datestr.substring(14,16));
   d.setSeconds(datestr.substring(17,19));
   return d;
}
function formatdateUTC(dateobj) {
   var year=dateobj.getUTCFullYear();
   var month=lpad2(dateobj.getUTCMonth()+1);
   var day=lpad2(dateobj.getUTCDate());
   var hour=lpad2(dateobj.getUTCHours());
   var min=lpad2(dateobj.getUTCMinutes());
   var sec=lpad2(dateobj.getUTCSeconds());
   var formatdatestr=year+'-'+month+'-'+day+' '+hour+':'+min+':'+sec;
   return formatdatestr;
}
function formatdate(dateobj) {
   var year=dateobj.getFullYear();
   var month=lpad2(dateobj.getMonth()+1);
   var day=lpad2(dateobj.getDate());
   var hour=lpad2(dateobj.getHours());
   var min=lpad2(dateobj.getMinutes());
   var sec=lpad2(dateobj.getSeconds());
   var formatdatestr=year+'-'+month+'-'+day+' '+hour+':'+min+':'+sec;
   return formatdatestr;
}
function lpad2(o) {
   if(o<10) {
      o='0'+o;
   }
   return o;
}

